# cli programs should be available on servers and desktop
{ config, pkgs, ... }:
{
  programs.zsh.enable = true;
  programs.fzf = {
    fuzzyCompletion = true;
    keybindings = true;
  };

  #  programs.neovim = {
  #  enable = true;
  #  defaultEditor = true;
  #  package = pkgs.neovim;
  #  viAlias = true;
  #  vimAlias = true;
  #};

  # List packages installed in system profile. To search, run:
  # $ nix search wget
  environment.systemPackages = with pkgs; [
    ansible
    atuin
    bat
    btop
    cargo
    catnip
    cmatrix
    coreutils
    curl
    dnsutils
    emacs-nox
    fd
    findutils
    fzf
    gnugrep
    gnumake
    gnupg
    imagemagick
    jq
    git
    glances
    htop
    lazygit
    lsd
    magic-wormhole
    mc
    micro
    mosh
    mpc-cli
    mpd
    mpv
    neofetch
    nixd
    neovim
    ollama
    pandoc
    pass
    pciutils
    pinentry
    ripgrep
    rustc
    slides
    starship
    syncthing
    tmux
    tokei
    tree
    unzip
    usbutils
    wget
    whois
    wl-clipboard
    wirelesstools
    yazi
    yt-dlp
    zellij
    zoxide
    zsh-autosuggestions
  ];
}
